import sys
from cx_Freeze import setup, Executable
import matplotlib
import os

# added all the file of folium package because cx_freeze don't add .js files
#I had to copy-paste the folder into the setup.py directory
include_files = list()
for root, dirs, files in os.walk('folium'):
    for f in files:
        include_files.append(root+'\\'+f)

# Dependencies are automatically detected, but it might need fine tuning.
build_exe_options = {"includes": ['__future__',
                                  'Tkinter',
                                  'tkFileDialog',
                                  'tkMessageBox',
                                  'ttk',
                                  'time',
                                  're',
                                  'requests',
                                  'urllib2',
                                  'difflib',
                                  'glob',
                                  'csv',
                                  'os',
                                  'shutil',
                                  'webbrowser',
                                  'tkFont',
                                  'operator',
                                  'collections',
                                  'base64',
                                  'locale',
                                  'shapefile',
                                  'gedcom',
                                  'geopy',
                                  'numpy',
                                  'matplotlib.cm',
                                  'matplotlib.colors',
                                  'folium',
                                  'staticmap',
                                  'packaging',
                                  'packaging.version',
                                  'packaging.specifiers',
                                  'packaging.requirements',
                                  'six'],
                     'excludes': ['collections.abc'],
                     'packages':['pkg_resources._vendor.packaging','six'],
                     'include_files':include_files}

#downgraded setuptools to version 19.2 excludes added because of bug : https://openclassrooms.com/forum/sujet/cx-freeze-no-file-named-sys
# added :
#'packaging', 'packaging.version', 'packaging.specifiers', 'packaging.requirements'
#because of this issue (#175) https://bitbucket.org/anthony_tuininga/cx_freeze/issues/175/importerror-the-packaging-package-is

base = None
if sys.platform == "win32":
    base = "Win32GUI"


setup(  name = "peregrination",
        version = "2.0",
        description = "Peregrination, a software to show the migration of your ancestor",
        options = {"build_exe": build_exe_options},
        executables = [Executable("Launcher.py", base=base)])
