__revision__ = "Test"
testname = "M1001_Common Code"

# import time, sys, os, errno, win32gui, win32ui, pymsgbox, win32com.client as win32
import time, os, errno, win32gui, win32com.client as win32
from pywinauto.application import Application
from ctypes import windll
from PIL import Image, ImageChops
# from FrameClass import cl_Capt

# Start SCM21 for USA warehouse
def df_SCMstart():
    global SCM, mn_SCM
    SCM = Application().Start(cmd_line=u'"D:\\Scm21Client_NEW_MVE\\Scm21.Client.exe" ')
    SCM.DcListForm.Wait('visible', timeout=20, retry_interval=0.5)
    SCM.DcListForm.TypeKeys("{ENTER 2}")
    mn_SCM = SCM.SCM21
    mn_SCM.Wait('ready', timeout=10, retry_interval=0.5)
    try:
        SCM.UpdateCheckForm.update.Wait('visible', timeout=7)
        SCM.UpdateCheckForm.update.Click()
    except:
        print('There is not the update for SCM21')


# Prepare an excel file for the test result
try:
    os.system("taskkill /im EXCEL.EXE")
    ex_Main = win32.gencache.EnsureDispatch('excel.Application')
    ex_Result = ex_Main.Workbooks.Open('D:\\SCM21_Functional Test_Auto.xlsx')
    os.remove('D:\\SCM21_AutomationTestResult.xlsx')
except OSError as e:
    if e.errno != errno.ENOENT:
        raise

df_SCMstart()

# Execute TC1 UI
try:
    mn_SCM.TypeKeys("{F10} {DOWN} {ENTER}"), time.sleep(5)
    mn_SCM[u'(M1001) CodeForm'].Wait('ready', timeout=20, retry_interval=1)
except:
    print('Failed')
    ex_Result.Worksheets("Master TC").Range("I7").Value = "Failed"
    os.system("taskkill /im Scm21.Client.exe")
    # it must move another menu.
    df_SCMstart()
else:
    print('Passed')
    ex_Result.Worksheets("Master TC").Range("I7").Value = "Passed"


# Execute TC9 Close the CodeForm
try:
    mn_SCM[u'Close'].Click()
    try:
        mn_SCM[u'(M1001) CodeForm'].Wait('visible')
    except:
        print("Passed")
        ex_Result.Worksheets("Master TC").Range("I15").Value = "Passed"
    else:
        print("Failed")
        ex_Result.Worksheets("Master TC").Range("I15").Value = "Failed"
        ex_Result.Worksheets("Master TC").Range("J15").Value = "Close button didn't work properly"
        os.system("taskkill /im Scm21.Client.exe")
        df_SCMstart()
except:
    print('Failed')
    ex_Result.Worksheets("Master TC").Range("I15").Value = "Failed"
    ex_Result.Worksheets("Master TC").Range("J15").Value = "Can't click 'Close' button"


# Execute TC7 Add the code
try:
    mn_SCM.TypeKeys("{F10} {DOWN} {ENTER}"), time.sleep(5)
    mn_SCM[u'(M1001) CodeForm'].Wait('ready', timeout=10, retry_interval=1)
    mn_SCM.Edit.Click(), time.sleep(2)
    mn_SCM.Add.Click(), time.sleep(2)
    mn_SCM[u'2'].SetFocus()
    mn_SCM.TypeKeys("{SPACE} {TAB} Z002 {TAB} TEST ADD {TAB} {SPACE} {TAB} 7777 {TAB} {SPACE} {TAB} {SPACE}"), time.sleep(3)
    mn_SCM.Save.Click(), time.sleep(2)
    SCM.Dialog[u'Save Completed'].Wait('ready', timeout=2, retry_interval=1)
    print("Passed")
    di_complete = SCM[u'Dialog']
    di_complete.Wait('visible', timeout=10, retry_interval=1)
    di_complete.OK.Click(), time.sleep(3)
    ex_Result.Worksheets("Master TC").Range("I12").Value = "Passed"
    mn_SCM[u'Close'].Click()
except:
    try:
        SCM.Dialog[u'class already exists.  Reenter new Class'].Wait('ready', timeout=5, retry_interval=1)
        va_num = 5
        while win32gui.FindWindow(None, 'Information') != 0:
            try:
                SCM.Dialog[u'Save Completed'].Wait('ready', timeout=1)
                break
            except:
                di_exist = SCM[u'Dialog']
                di_exist.Wait('visible', timeout=5, retry_interval=1)
                di_exist.OK.Click(), time.sleep(3)
                va_num = va_num + 1
                va_class = str(va_num).rjust(3, '0')
                va_classname = "Z" + va_class
                mn_SCM[u'2'].SetFocus()
                mn_SCM.TypeKeys("{RIGHT 6} {LEFT 5}" + va_classname), time.sleep(3)
                mn_SCM.Save.Click(), time.sleep(3)
        di_complete = SCM[u'Dialog']
        di_complete.Wait('visible', timeout=10, retry_interval=1)
        di_complete.OK.Click(), time.sleep(3)
        print("Passed")
        ex_Result.Worksheets("Master TC").Range("I12").Value = "Passed"
        mn_SCM[u'Close'].Click()
    except:
        print('Failed')
        ex_Result.Worksheets("Master TC").Range("I12").Value = "Failed"
        ex_Result.Worksheets("Master TC").Range("J12").Value = "An error occurred during the testing"
        os.system("taskkill /im Scm21.Client.exe")
        df_SCMstart()


# Execute TC6 Edit the code
try:
    mn_SCM.TypeKeys("{F10} {DOWN} {ENTER}"), time.sleep(5)
    mn_SCM[u'(M1001) CodeForm'].Wait('ready', timeout=20, retry_interval=1)
    mn_SCM.TypeKeys("{PGDN 20}"), time.sleep(3)
    mn_SCM[u'(M1001) CodeForm'].Wait('ready', timeout=20, retry_interval=1)
    mn_SCM.TypeKeys("{UP}"), time.sleep(3), mn_SCM.TypeKeys("{DOWN}"), time.sleep(3)
    im_before = cl_Capt().df_main('Before')
    mn_SCM.Edit.Click()
    mn_SCM[u'2'].SetFocus()
    mn_SCM.TypeKeys("{SPACE} {TAB 3} {SPACE} {TAB} 7777 {TAB} {SPACE} {TAB} {SPACE}")
    mn_SCM.Save.Click()
    di_complete = SCM[u'Dialog']
    di_complete.Wait('visible', timeout=20, retry_interval=1)
    di_complete.OK.Click(), time.sleep(3)
    mn_SCM[u'(M1001) CodeForm'].Wait('ready', timeout=20, retry_interval=1)
    mn_SCM[u'Close'].Click()
    mn_SCM.Wait('ready', timeout=20, retry_interval=1)
    mn_SCM.TypeKeys("{F10} {DOWN} {ENTER}"), time.sleep(3)
    mn_SCM[u'(M1001) CodeForm'].Wait('ready', timeout=20, retry_interval=1)
    mn_SCM.TypeKeys("{PGDN 20}"), mn_SCM[u'(M1001) CodeForm'].Wait('ready', timeout=20, retry_interval=1), time.sleep(
        3)
    mn_SCM.TypeKeys("{UP}"), time.sleep(3),mn_SCM.TypeKeys("{DOWN}"), time.sleep(3)
    im_after = cl_Capt().df_main('After')
    if im_before != im_after:
        print("Passed")
        ex_Result.Worksheets("Master TC").Range("I12").Value = "Passed"
        mn_SCM[u'Close'].Click()
    else:
        print("Failed")
        ex_Result.Worksheets("Master TC").Range("I12").Value = "Failed"
        ex_Result.Worksheets("Master TC").Range("J12").Value = "The edit function didn't work properly"
        os.system("taskkill /im Scm21.Client.exe")
        df_SCMstart()
except:
    print('Failed')
    ex_Result.Worksheets("Master TC").Range("I12").Value = "Failed"
    ex_Result.Worksheets("Master TC").Range("J12").Value = "An error occurred during the testing"
    os.system("taskkill /im Scm21.Client.exe")
    df_SCMstart()


# Execute TC7 Edit the code that has class 0007, 0076
try:
    mn_SCM.TypeKeys("{F10} {DOWN} {ENTER}"), time.sleep(5)
    mn_SCM[u'(M1001) CodeForm'].Wait('ready', timeout=20, retry_interval=1)
    mn_SCM.Edit.Click()
    mn_SCM[u'2'].SetFocus()
    mn_SCM.TypeKeys("{DOWN 6}"), time.sleep(3), mn_SCM.TypeKeys("{SPACE}"), time.sleep(1)
    mn_SCM.Save.Click()
    di_complete = SCM[u'Dialog']
    di_complete.Wait('visible', timeout=20, retry_interval=1)
    di_complete.OK.Click()
    pu_term = SCM[u'(M9001) Date Term/Incoterms']
    pu_term.Wait('ready', timeout=20, retry_interval=1)
    pu_term.Close(), time.sleep(2)
    print("Passed")
    ex_Result.Worksheets("Master TC").Range("I13").Value = "Passed"
    mn_SCM[u'Close'].Click(), time.sleep(1)
except:
    print('Failed')
    ex_Result.Worksheets("Master TC").Range("I13").Value = "Failed"
    ex_Result.Worksheets("Master TC").Range("J13").Value = "An error occurred during the testing"
    os.system("taskkill /im Scm21.Client.exe")
    df_SCMstart()


# Execute TC8 Cancel the edit mode
try:
    mn_SCM.TypeKeys("{F10} {DOWN} {ENTER}"), time.sleep(5)
    mn_SCM[u'(M1001) CodeForm'].Wait('ready', timeout=20, retry_interval=1)
    im_before = cl_Capt().df_main('Before')
    mn_SCM.Edit.Click()
    mn_SCM[u'2'].SetFocus()
    mn_SCM.TypeKeys("{SPACE} {TAB 3} {SPACE} {TAB} 7777 {TAB} {SPACE} {TAB} {SPACE}")
    mn_SCM.Cancel.Click(), time.sleep(2), mn_SCM.TypeKeys("{TAB}"), time.sleep(1), mn_SCM.TypeKeys("{TAB}"), time.sleep(1)
    im_after = cl_Capt().df_main('After')
    if im_before == im_after:
        print("Passed")
        ex_Result.Worksheets("Master TC").Range("I12").Value = "Passed"
        mn_SCM[u'Close'].Click()
    else:
        print("Failed")
        ex_Result.Worksheets("Master TC").Range("I12").Value = "Failed"
        ex_Result.Worksheets("Master TC").Range("J12").Value = "The cancel function didn't work properly"
        os.system("taskkill /im Scm21.Client.exe")
        df_SCMstart()
except:
    print('Failed')
    ex_Result.Worksheets("Master TC").Range("I14").Value = "Failed"
